<script setup>
  import { ref, watch } from 'vue';
  import ListeFichesDePaie from '@/components/listes/ListeFichesDePaie.vue';
  import axios from 'axios'
  import ROUTES_API from '@/assets/routesAPI.js'
  import BoutonRechercher from '@/components/boutons/BoutonRechercher.vue';
    
  const fichesDePaies = ref([]);

  const critere = ref('toutes');

  const personnel = ref([]);

  const salaire = ref();
  const date = ref();
  const idEmploye = ref(null);

  function rechercherFichesDePaie() {
    let route = ROUTES_API.FICHES_DE_PAIE
    if (critere.value === 'salaire-inf') {
      route += '/salaireBrutPlusPetitQue/' + salaire.value * 100;
    } else if (critere.value === 'salaire-sup') {
      route += '/salaireBrutPlusGrandQue/' + salaire.value * 100;
    } else if (critere.value === 'date') {
      route += '/date/' + date.value;
    } else if (critere.value === 'employe') {
      route += '/employe/' + idEmploye.value;
    }

    axios.get(route, {
      headers : {
        'Content-Type': 'application/json',
        'Accept': 'application/json'
      }
    })
    .then(response => {
      if (response.data) {
        fichesDePaies.value = response.data;
      }    
    })
    .catch(e => {})
  }

  function rechercherPersonnel() {
    axios.get(ROUTES_API.PERSONNEL, {
      headers : {
        'Content-Type': 'application/json',
        'Accept': 'application/json'
      }
    })
    .then(response => {
      if (response.data) {
        personnel.value = response.data;
      }
    })
    .catch(e => {})
  }

  watch(critere, (val) => {
    if (val === 'toutes') {
      salaire.value = null;
      date.value = null;
    } else if (val === 'salaire-inf' || val === 'salaire-sup') {
      date.value = null;
    } else if (val === 'date') {
      salaire.value = null;
    } else if (val === 'employe') {
      rechercherPersonnel();
      date.value = null;
      salaire.value = null;
    }
  })

  function supprimerFicheDePaie(id) {
    axios.delete(ROUTES_API.FICHES_DE_PAIE + id, {
      headers : {
        'Content-Type': 'application/json',
        'Accept': 'application/json'
      }
    })
    .then(_ => {
        rechercherFichesDePaie();
    })
    .catch(e => {})
  }

  rechercherFichesDePaie();
</script>

<template>
  <div>
    <div class="recherche">
      <select class="form-select" v-model="critere">
        <option value="toutes" selected>Toutes</option>
        <option value="salaire-inf">Salaire inférieur à</option>
        <option value="salaire-sup">Salaire supérieur à</option>
        <option value="date">Date</option>
        <option value="employe">Employé</option>
      </select>
      <select class="form-select" v-if="critere === 'employe'" v-model="idEmploye">
        <option v-for="employe in personnel" :value="employe.id">{{ employe.nom }} {{ employe.prenom }} ({{ employe.role }})</option>
      </select>

      <input type="number" class="form-control" placeholder="Salaire" v-if="critere === 'salaire-inf' || critere === 'salaire-sup'" v-model="salaire"/>
      <input type="date" class="form-control" v-if="critere === 'date'" v-model="date"/>
      <BoutonRechercher @rechercher="rechercherFichesDePaie"/>
    </div>
    <ListeFichesDePaie :fiches-de-paies="fichesDePaies" @supprimer="supprimerFicheDePaie"/>
  </div>
</template>

<style scoped>
  .recherche {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    margin-bottom: 10px;
  }

  .recherche select, .recherche input {
    flex: 1;
    margin-right: 10px;
  }
</style>